Index: cli.c
===================================================================
--- cli.c	(revision 334948)
+++ cli.c	(working copy)
@@ -1390,6 +1390,7 @@
 	char nf[256], wf[256], rf[256];
 	struct ast_str *write_transpath = ast_str_alloca(256);
 	struct ast_str *read_transpath = ast_str_alloca(256);
+	struct ast_str *output = ast_str_alloca(8192);
 	long elapsed_seconds=0;
 	int hour=0, min=0, sec=0;
 #ifdef CHANNEL_TRACE
@@ -1430,7 +1431,7 @@
 		strcpy(cdrtime, "N/A");
 	}
 
-	ast_cli(a->fd, 
+	ast_str_append(&output, 0,
 		" -- General --\n"
 		"           Name: %s\n"
 		"           Type: %s\n"
@@ -1489,24 +1490,23 @@
 		( c-> data ? S_OR(c->data, "(Empty)") : "(None)"),
 		(ast_test_flag(c, AST_FLAG_BLOCKING) ? c->blockproc : "(Not Blocking)"));
 	
-	if (pbx_builtin_serialize_variables(c, &out)) {
-		ast_cli(a->fd,"      Variables:\n%s\n", ast_str_buffer(out));
-	}
+	if (pbx_builtin_serialize_variables(c, &out))
+		ast_str_append(&output, 0, "      Variables:\n%s\n", ast_str_buffer(out));
 
-	if (c->cdr && ast_cdr_serialize_variables(c->cdr, &out, '=', '\n', 1)) {
-		ast_cli(a->fd,"  CDR Variables:\n%s\n", ast_str_buffer(out));
-	}
+	if (c->cdr && ast_cdr_serialize_variables(c->cdr, &out, '=', '\n', 1))
+		ast_str_append(&output, 0, "  CDR Variables:\n%s\n", ast_str_buffer(out));
 
 #ifdef CHANNEL_TRACE
 	trace_enabled = ast_channel_trace_is_enabled(c);
-	ast_cli(a->fd, "  Context Trace: %s\n", trace_enabled ? "Enabled" : "Disabled");
+	ast_str_append(&output, 0, "  Context Trace: %s\n", trace_enabled ? "Enabled" : "Disabled");
 	if (trace_enabled && ast_channel_trace_serialize(c, &out))
-		ast_cli(a->fd, "          Trace:\n%s\n", ast_str_buffer(out));
+		ast_str_append(&output, 0, "          Trace:\n%s\n", ast_str_buffer(out));
 #endif
 
 	ast_channel_unlock(c);
 	c = ast_channel_unref(c);
 
+	ast_cli(a->fd, "%s", ast_str_buffer(output));
 	return CLI_SUCCESS;
 }
 
